#!/usr/bin/python
#
# test.py - Test script.
# Copyright (C) 2005  shinGETsu Project.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
#
# $Id: test.py,v 1.1 2005/03/11 12:59:13 fuktommy Exp $
#

import os
import socket
import sys
import urllib

__version__ = "$Revision: 1.1 $"

sys.path.append("..")

import shingetsu.config


def test_apollo():
    import shingetsu.apollo
    (pubkey, prikey) = shingetsu.apollo.key_pair("abcdefgh")
    return pubkey.startswith("HFYd4FUjxeXPcdebrhJac4s/dEDN7Yp9") and \
           prikey.startswith("R7Cncv9MnBXm4LEp9/9oT7MT0UxDTIoL")

def test_httpd():
    import shingetsu.httpd
    httpd = shingetsu.httpd.Httpd()
    httpd.setDaemon(True)
    os.chdir("..")
    httpd.start()

    socket.setdefaulttimeout(shingetsu.config.timeout)
    try:
        u = urllib.urlopen("http://www.genie.x0.com/gtl/help/port_scan.php?" +
                           "port=" + str(shingetsu.config.port))
        buf = u.read()
        u.close()
        return buf.find("(\xA5\x81\xCD\xA5) \x90\xAC\x8C\xF7") > 0
    except IOError:
        return False

def main():
    if test_apollo():
        print "Apollo OK"
    else:
        print "Apollo NG"

    if test_httpd():
        print "HTTPD OK"
    else:
        print "HTTPD NG"

if __name__ == "__main__":
    main()
