#!/usr/bin/python
#
# save logs to /LOGDIR/%Y-%m-%d .
#
# Copyright (C) 2005  shinGETsu Project.
# $Id: datelog.py,v 1.1 2005/02/28 15:45:02 fuktommy Exp $
#

import sys
import time

if len(sys.argv) != 2:
    sys.exit(1)

log_dir = sys.argv[1]

sys.stdout.close()
sys.stderr.close()

log = ""
while True:
    line = sys.stdin.readline()
    if line == "":
        break
    new_log = log_dir + "/" + time.strftime("%Y-%m-%d", time.localtime())
    if log == new_log:
        pass
    elif log == "":
        log = new_log
        f = file(log, "a")
    else:
        f.close()
        log = new_log
        f = file(log, "a")
    f.write(line)
    f.flush()
f.close()
